
#region Copyright Syncfusion Inc. 2001-2018.
// Copyright Syncfusion Inc. 2001-2018. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
using Syncfusion.WinForms.Controls;
using Syncfusion.WinForms.DataGrid.Styles;
using System.Windows.Forms;
using Syncfusion.WinForms.DataGrid.Enums;
using Syncfusion.WinForms.DataGrid;
using Syncfusion.Data;
using Syncfusion.WinForms.DataGrid.Interactivity;
using Syncfusion.WinForms.Input;
using Syncfusion.WinForms.DataGrid.Renderers;
using System.Reflection;
using System.Globalization;

namespace GettingStarted
{   
    public partial class Form1 : Form
    {
        #region Constructor
        public Form1()
        {
            InitializeComponent();
            var data = new OrderInfoCollection();
            sfDataGrid.ShowBusyIndicator = true;
            sfDataGrid.AutoGenerateColumns = false;
            this.sfDataGrid.CellRenderers.Remove("Numeric");
            this.sfDataGrid.CellRenderers.Add("Numeric", new GridNumericCellRendererExt());
            sfDataGrid.DataSource = data.OrdersListDetails;

            NumberFormatInfo numberFormat = Application.CurrentCulture.NumberFormat.Clone() as NumberFormatInfo;
            numberFormat.NumberDecimalDigits = 0;

            GridNumericColumn numericColumn1 = new GridNumericColumn();
            numericColumn1.MappingName = "OrderID";
            numericColumn1.FormatMode = Syncfusion.WinForms.Input.Enums.FormatMode.Numeric;
            numericColumn1.NumberFormatInfo = numberFormat;
            sfDataGrid.Columns.Add(numericColumn1);
            
            GridNumericColumn numericColumn2 = new GridNumericColumn();
            numericColumn2.MappingName = "Quantity";
            numericColumn2.FormatMode = Syncfusion.WinForms.Input.Enums.FormatMode.Numeric;
            numericColumn2.NumberFormatInfo = numberFormat;
            sfDataGrid.Columns.Add(numericColumn2);

            GridTextColumn textColumn = new GridTextColumn();
            textColumn.MappingName = "ProductName";
            sfDataGrid.Columns.Add(textColumn);

            sfDataGrid.LiveDataUpdateMode = LiveDataUpdateMode.AllowDataShaping;
          
        }

        #endregion
    }

    public class GridNumericCellRendererExt : GridNumericCellRenderer
    {
        string previewInputText1 = string.Empty;
        protected override void OnKeyPress(DataColumnBase dataColumn, Syncfusion.WinForms.GridCommon.ScrollAxis.RowColumnIndex rowColumnIndex, KeyPressEventArgs e)
        {
            var dataGrid =(SfDataGrid)((this.TableControl.GetType().GetProperty("DataGrid", System.Reflection.BindingFlags.Instance | System.Reflection.BindingFlags.NonPublic | BindingFlags.Public)).GetValue(this.TableControl));

            if (!dataGrid.CurrentCell.IsEditing && e.KeyChar == '-')
            {
                var previewInputText = ((dataGrid.CurrentCell.CellRenderer.GetType().GetProperty("PreviewInputText", System.Reflection.BindingFlags.Instance | System.Reflection.BindingFlags.NonPublic | BindingFlags.Public)));
                previewInputText.SetValue(dataGrid.CurrentCell.CellRenderer, e.KeyChar.ToString());
                previewInputText1 = e.KeyChar.ToString();
                dataGrid.CurrentCell.BeginEdit();
            }
            else
                base.OnKeyPress(dataColumn, rowColumnIndex, e);
        }

        protected override void OnInitializeEditElement(DataColumnBase column, Syncfusion.WinForms.GridCommon.ScrollAxis.RowColumnIndex rowColumnIndex, SfNumericTextBox uiElement)
        {
            var dataGrid =(SfDataGrid)((this.TableControl.GetType().GetProperty("DataGrid", System.Reflection.BindingFlags.Instance | System.Reflection.BindingFlags.NonPublic | BindingFlags.Public)).GetValue(this.TableControl));
            double value;
            var previewText = (string) ((dataGrid.CurrentCell.CellRenderer.GetType().GetProperty("PreviewInputText", System.Reflection.BindingFlags.Instance | System.Reflection.BindingFlags.NonPublic | BindingFlags.Public))).GetValue(dataGrid.CurrentCell.CellRenderer);
            if (double.TryParse(previewInputText1, out value) || previewInputText1 == string.Empty)
                base.OnInitializeEditElement(column, rowColumnIndex, uiElement);
            else
            {
                uiElement.Value = -1;
                uiElement.Focus();
                base.OnInitializeEditElement(column, rowColumnIndex, uiElement);
            }
        }
    }
}
